% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lrelu.R
\name{dlReLU}
\alias{dlReLU}
\title{Derivative of Leaky ReLU activation function}
\usage{
dlReLU(x)
}
\arguments{
\item{x}{numeric vector}
}
\value{
numeric vector
}
\description{
Derivative of Leaky ReLU activation function
}
\examples{

dlReLU(c(-1, 0, 1))

# Can use in rxode2 as well

r <- rxode2({r <- dlReLU(time)})
e <- et(c(-1, 0, 1))
rxSolve(r, e)

}
\seealso{
Other Activation Functions: 
\code{\link{ELU}()},
\code{\link{GELU}()},
\code{\link{PReLU}()},
\code{\link{ReLU}()},
\code{\link{SELU}()},
\code{\link{Swish}()},
\code{\link{dELU}()},
\code{\link{dGELU}()},
\code{\link{dPReLU}()},
\code{\link{dReLU}()},
\code{\link{dSELU}()},
\code{\link{dSwish}()},
\code{\link{dsoftplus}()},
\code{\link{lReLU}()},
\code{\link{softplus}()}
}
\concept{Activation Functions}
