% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/softplus.R
\name{dsoftplus}
\alias{dsoftplus}
\alias{d2softplus}
\alias{d3softplus}
\alias{d4softplus}
\title{Default Softplus Activation Function}
\usage{
dsoftplus(x)

d2softplus(x)

d3softplus(x)

d4softplus(x)
}
\arguments{
\item{x}{numeric vector}
}
\value{
numeric vector
}
\description{
Default Softplus Activation Function
}
\examples{

dsoftplus(c(-1, 0, 1, 2))

# You can use rxode2 too:

r <- rxode2({
 s1 <- dsoftplus(time)
})

e <- et(c(-1, 0, 1, 2))

rxSolve(r, e)

}
\seealso{
Other Activation Functions: 
\code{\link{ELU}()},
\code{\link{GELU}()},
\code{\link{PReLU}()},
\code{\link{ReLU}()},
\code{\link{SELU}()},
\code{\link{Swish}()},
\code{\link{dELU}()},
\code{\link{dGELU}()},
\code{\link{dPReLU}()},
\code{\link{dReLU}()},
\code{\link{dSELU}()},
\code{\link{dSwish}()},
\code{\link{dlReLU}()},
\code{\link{lReLU}()},
\code{\link{softplus}()}
}
\author{
Matthew L. Fidler
}
\concept{Activation Functions}
